(game-module "flattop"
  (title "Flattop")
  (blurb "WW II, in the Pacific, aboard a carrier")
;  (blurb "Carrier operations in the Pacific")
)

(set see-all true)

(unit-type f (name "fighter") (help ""))
(unit-type d (name "dive bomber") (help ""))
(unit-type t (name "torpedo bomber") (help ""))
(unit-type p (name "PBY") (help ""))
(unit-type D (name "destroyer") (help ""))
(unit-type S (name "submarine") (help ""))
(unit-type E (name "escort carrier") (help ""))
(unit-type r (name "light cruiser") (help ""))
(unit-type R (name "heavy cruiser") (help ""))
(unit-type C (name "carrier") (help ""))
(unit-type B (name "battleship") (help ""))
(unit-type / (name "base") (help ""))

(material-type fuel (help "how to get around"))
(material-type ammo (help "small stuff"))
(material-type shell (help "8 to 16 inch"))
(material-type bomb (help "iron bombs"))
(material-type torps (help "death to ships"))

(define o fuel)
(define a ammo)
(define A shell)
(define b bomb)
(define ! torps)

(terrain-type sea (char ".") (color "sky blue"))
(terrain-type atoll (char ",") (color "cyan"))
(terrain-type island (char "+") (color "forest green") (image-name "forest"))

(add f image-name "1e")
(add d image-name "1e")
(add t image-name "torp-bomber")
(add p image-name "pby")
(add D image-name "dd")
(add r image-name "ca")
(add S image-name "sub")
(add E image-name "cv")
(add C image-name "cv")
(add R image-name "ca")
(add B image-name "bb")
(add / image-name "airbase")

(define air (f d t p))
(define heavy (r R B))
(define carriers (E C))
(define ships (D S E r R C B))
(define stuff (o a A b !))

;true / always-seen

;;; Any number of aircraft can share the same airspace.

(table unit-size-in-terrain
  (air t* 0)
  )

(table unit-size-as-occupant
  (air carriers 1)
  (air / 1)
  (ships carriers 100)
  (ships / 1)
  )

(add carriers capacity (4 8))
(add / capacity 100)

;100 u* u* enter-time

;500 (fuel ammo) ships storage
;20 fuel air storage
;40 fuel p storage
;2 a air storage
;0 a p storage
;2 b d storage
;2 ! t storage
;10 ! (D S) storage
;50 (b !) C storage
;25 (b !) E storage
;50 A heavy storage
;1000 r* / storage

;3 fuel air consume

(add air acp-per-turn 9)
(add p acp-per-turn 6)
(add ships acp-per-turn 3)

(add / acp-per-turn 1)

(add air speed 9)
(add p speed 6)
(add ships speed 3)

(table mp-to-enter-terrain
  (ships atoll 2)
  (ships island 10)
  )

;1 fuel u* to-move

;10 S visibility

(add ships hp-max (5 5 5 5 10 10 20))
(add / hp-max 100)

(add table hit-chance (u* u* 50))
(add table hit-chance (f air 80))
(add table hit-chance (f f 60))
(add table hit-chance (p u* 0))
(add table hit-chance (f carriers 20))
(add table hit-chance (S air 20))
(add table hit-chance (D S 70))
(add table hit-chance (u* / 100))
;0 / (S E C) hit-chance
(add table hit-chance (carriers u* 10))

(add table damage (u* u* 1))
(add table damage (heavy u* 3))
;4 ships (t D S) damage
;10 (C B) (t D S) damage
(add table damage (B / 10))

;(add table hits-with (air a 1))
;1 a (E C) hits-with
;(add table hits-with (d b 1))
;1 ! (t D S) hits-with
;(add table hits-with (heavy A 1))

;1 (b !) ships hit-by
(add table hit-by (air a 1))
(add table hit-by (u* A 1))

;50 air carriers protect

;"sinks" ships destroy-message
;"shoots down" air destroy-message

;; 0 air control

(game-module (notes (
   "This is a somewhat expanded version of the navy in the standard period. "
   "Each side commands a large fleet, and the sole objective is to wipe out "
   "the enemy's fleet.  There are different kinds of planes and ships, but "
   "nothing else."

   "Speeds of ships are uniform, so that formations work better (don't want "
   "the carriers outstripping their escorts). "

   "You do *not* get complete control over the aircraft!  Those undisciplined "
   "pilots just do what they feel like doing, and only take about half their "
   "orders."
  )))

(add t* alt-percentile-min (  0  96  98))
(add t* alt-percentile-max ( 96  98 100))
(add t* wet-percentile-min 0)
(add t* wet-percentile-max 100)

(set edge-terrain sea)

(set country-radius-min 4)
(set country-separation-min 30)
(set country-separation-max 32)

(add u* start-with (8 8 8 4 6 2 4 2 2 2 2 1))

(table favored-terrain
  (u* t* 0)
  (ships sea 100)
  (/ (atoll island) 100)
  )

(side-library set
  ((noun "American") (emblem-name "flag-usa"))
  ((noun "Japanese") (emblem-name "flag-japan"))
  )

(include "ng-ships")

;; need to make side-specific eventually
(add R namer "american-ca-names")
(add C namer "american-cv-names")
(add B namer "american-bb-names")

(scorekeeper (do last-side-wins))
