(game-module "voyages"
  (title "Voyages of Discovery")
  (blurb "Sail across uncharted seas, find new lands")
  (variants (world-seen) (world-size 80 40))
)

;; should be a self-unit (?) with 2-3 hex radius of control

(unit-type explorer (image-name "stan") ; needs a better icon...
  (help "our hero")
  (acp-per-turn 2) (speed 2)
  (hp-max 3)
  )

(unit-type crew (image-name "soldiers")
  (help "supports the explorer")
  (acp-per-turn 1) (speed 1)
  (hp-max 30) (parts-max 30) 
  )

(unit-type fleet (image-name "caravel-fleet")
  (help "transportation across the sea")
  (acp-per-turn 14) (speed 14)
  (hp-max 30) (parts-max 3)
  )

;;; What the crew can build to live in.  This is not a port however, ships must
;;; remain at sea.

(unit-type fort (image-name "walltown"))

(unit-type city (image-name "city18")
  (help "Home port, with nearly limitless supply"))

(unit-type native-village (image-name "village"))

(unit-type native-city (image-name "city18"))

;;; Need different kinds of natives (savages, E. Indians, etc).

(define places (fort city native-village native-city))

;; the essentials
(material-type food)
(material-type water)
(material-type wood)
;; the goals
(material-type gold)
(material-type gems)
(material-type spices)

;;; The usual collection of terrain types.
;;; (perhaps should flush in favor of smaller set? - no roads needed for instance)

(include "stdterr")

(define land (swamp desert plains forest mountains ice))
(define waters (sea shallows))

;;; Static relationships.

(table vanishes-on
  ((explorer crew) waters true)
)

(table wrecks-on
  (fleet land true)
)

(add fleet wrecked-type fort)

(table unit-capacity-x
  (fleet (explorer crew) (3 3))
  (city (explorer crew) (100 30))
  (native-city (explorer crew) (100 30))
)

;(table material-capacity
;  ((explorer crew) (food water) 2)
;  (fleet (food water) 20)
;)

;;; Vision.

;; (nothing special needed?)

;;; Action parameters.

;;; Movement.

(table mp-to-enter-terrain
  ;; these are for accident prevention...
  ((explorer crew) waters 99)
  (fleet land 99)
  )

;;; Construction.

;;; Combat.

(table capture-chance
  (explorer places 10)
  )

;;; Random events.

(table accident-vanish-chance
  (fleet waters (30 10))
  )

;;; Starting material for random setups.

(define country-radius-min 2)

(add (sea plains) country-terrain-min (1 3))

(add (explorer crew fleet city) start-with (1 1 1 1))

(table favored-terrain
  (u* t* 0)
  ((explorer crew) plains 100) 
  (city plains 100)
  (fleet sea 100)
  ((native-village native-city) land 100)
  )

(add city initial-seen-radius 6)

(table independent-density
  (native-village (plains forest mountains) (100 50 20))
  (native-city plains 10)
  )

;;; This works as a solo game.

(set sides-min 1)

(independent-units (emblem-name "none"))  ; should be the default eventually

;;; should always generate a globe-girdling area to play on.

(game-module
  (notes
	"might want a general operates-equipment relation so crew can move via
	ships but can still leave, thus immobilizing the ships"
	"explorer would have to manage crews properly"

	"crews on land can collect water/food and store on ship"

	"forts protect crew while they forage(?)"

	"high chance of attrition for crew"
	"Explorer only vulnerable to combat or starvation however"

	"need to do storms somehow (stripped-down lat-based weather model?)"

  "Turn length is about a week."
 ))
