/* Copyright (c) 1992  Stanley T. Shebs. */
/* This program may be used, copied, modified, and redistributed freely */
/* for noncommercial purposes, so long as this notice remains intact. */

/* Definitions common to all AIs. */

typedef enum {
    nobrains = 0,
    mplayertype = 1
    /* plus other types as desired */
} AIType;

/* Definition common to all ai type. (?) */

typedef struct a_ai {
  AIType type;
} AI;

#define side_ai_type(s) (((AI *) (s)->ai)->type)

/* A goal is a predicate object that can be tested to see whether it has
   been achieved.  As such, it is a relatively static object and may be
   shared.  The truth value of a goal is more dynamic, depends on who's
   testing it, and it is a "fuzzy" value.  Range is from 100 (definitely true)
   to 0 (completely unknown) to -100 (definitely untrue).  In-between numbers
   indicate the degree of certainty. */

/* The different types of goals. */

typedef enum goaltype {

#undef  DEF_GOAL
#define DEF_GOAL(GOALTYPE,desc,args) GOALTYPE,

#include "goal.def"

    g_t_dummy
} GoalType;

/* The structure proper. */

typedef struct a_goal {
    GoalType type;
    long arg[10];
} Goal;

/* The structure that ties truth values to the goal. */

typedef struct a_goalstate {
    struct a_goal *goal;    /* the goal proper */
    Side *side;             /* which side the goal applies to */
    int state;              /* its current truth value */
    int evaldate;           /* when the value was computed */
    struct a_goalstate *next;
} GoalState;

/* Add declaration of AI hooks here. */

extern char *aitypenames[];

Goal *create_goal();
GoalState *create_goalstate();
char *goal_desig();
char *goalstate_desig();

